#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false) ;
    cin.tie(0) ;
    cout.tie(0) ;
    int n  ;
    cin >>n ;
    int a[n] ;
    int niz[50]={0} ;
    int b  ;
    for(int i=0 ; i<n ; i++){
        cin >> a[i] ;
        b=a[i] ;
        int j=0 ;
        while(b>0){
            niz[j]+=b%2 ;
            b/=2 ;
            j++ ;
        }
    }
    int q  ;
    cin >> q  ;
    int k ,x ,t  ;
    for(int i=0 ; i<q ; i++){
        cin >> t ;
        if(t==0){
            cin >> k ;
            int br=0 ;
            int st=1 ;
            for(int j=0 ; j<50 ; j++){
                br+=max(min(niz[j]-k+1,1),0)*st ;
                st*=2 ;
            }
            cout << br << endl ;
        }
        else{
            cin >> k >> x  ;
            int j=0 ;
            int c=a[k-1] ;
            while(c>0){
                niz[j]-=c%2 ;
                j++ ;
                c/=2 ;
            }
            while(x>0){
                niz[j]+=x%2 ;
                j++ ;
                x/=2 ;
            }

        }
    }
    return 0;
}